
//import java.awt.*;
//import java.awt.event.*;


public class Gravity2 {
	
	int N               = 20000;                  //  Anzahl Partikel
	
	double posX []      = new double [N];     // Positionen
	double posY []      = new double [N];
	
	double newPosX []      = new double [N];     // Positionen
	double newPosY []      = new double [N];
	
	double veloX []     = new double [N];     // Geschwindigkeiten
	double veloY []     = new double [N];
	
	double forceX []    = new double [N];     // Kraefte
	double forceY []    = new double [N];
	
	double centerMass []      = new double [N];     // Massen
	double mass []      = new double [N];
	double velSize[]	= new double [N];  
	double dec[] = new double [N];
	double dt           = 0.01f;               // Zeitschritt
	double c = 5;
	double p = 4;
	boolean mouseClicked = false;
	double mouseX;
	double mouseY;
	int moveCounter = 0;
	int charCount = 0;
	
	public Gravity2(int N, int grav) {
		for (int i=0;i<N;i++){
			centerMass[i] = 0;                        
			mass[i] = 0.5;
			dec[i] =1;
			posX[i] = 350.0;                           
			posY[i] = 350.0;
			newPosX[i] = 280.0;
			newPosY[i] = 300.0;
		}
	}
	
	public void getForces(int i) {
		// Lineare Rueckstellkraft (Federkraft, anziehend)
		forceX[i] = -mass[i]*dist(i)*(newPosX[i]-posX[i])-c*veloX[i];
		forceY[i] = -mass[i]*dist(i)*(newPosY[i]-posY[i])-c*veloY[i];
		if (mouseClicked) {
			
			forceX[i] =- p *dist(i) * (newPosX[i]-mouseX);
			forceY[i] =- p *dist(i) * (newPosY[i]-mouseY);
			if(moveCounter<=charCount){
				moveCounter++;
			}else{
				mouseClicked = false;
				moveCounter=0;
			}
		}
		
	}
	
	public void iterateGauss(int i) {
		getForces(i);		                   // Berechnung der neuen Kraefte
		
		veloX[i] += dt*forceX[i];              // neue Geschwindigkeiten
		veloY[i] += dt*forceY[i];
		veloX[i]*=dec[i];
		veloY[i]*=dec[i];
		newPosX[i]  += dt*veloX[i];               // neue Positionen
		newPosY[i]  += dt*veloY[i];
		//        dec[i]*=0.999;
		//        dec[i]*=1.001;
	}
	
	public double dist(int i) {
		return Math.sqrt((newPosX[i]-posX[i])*(newPosX[i]-posX[i])+
			(newPosY[i]-posY[i])*(newPosY[i]-posY[i]));
	}
}

